<?php
/**
* A little web site to create a zip file of the actual tracks from a server and the corresponding tracklist file. The zip file includes the
* whole directory path, and it will be linked afterwards to be able to directly download it. there is also a function to list all existing 
* zip files and download them. each successfull backup will be logged in a file. log file need write permission of course. 
* same with the ZIP folder.
*
* the zip function is based on Schmidis MapPack, thanks for that. :)  
*
* hope you'll like it.
*
* by Nouseforname
*
**/

#============================================== configuration =======================================================#

// config server  "IP", "PORT", "Admin", "ADMINPW" , "NAME", "tracklist.txt" ;   NAME is also part of zip file name
//$server[] = array("localhost", "5000", "Admin", "PASSWORD", "SERVERNAME", "tracklist.txt");
$server[] = array("localhost", "5001", "Admin", "PW", "Server1", "tracklist.txt");
$server[] = array("localhost", "5002", "Admin", "PW", "Server2", "tracklist.txt");

#===================================== don't change anything belo here =================================================#

	require("./classes/GbxRemote.inc.php");
	require("./classes/tmfcolorparser.inc.php");

	$handle = fopen("backup.log","a");
	$date = date("Y-m-d"); 
	$cp= new TMFColorParser();
				
	//  define break  
	$max = 500;
	$i = 0;
	
	// format the file size
	function formatBytes($bytes, $precision = 1) {
		$units = array('B', 'KB', 'MB', 'GB', 'TB');
		$bytes = max($bytes, 0);
		$pow = floor(($bytes ? log($bytes) : 0) / log(1024));
		$pow = min($pow, count($units) - 1);
		$bytes /= pow(1024, $pow);
		return round($bytes, $precision) . ' ' . $units[$pow];
	} 
	
$output = '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" >
<link rel="shortcut icon" href="favicon.ico" >
<title>TrackmaniaServer backup track tool by Nouseforname</title>
<meta name="author" content="Nouseforname" >
<style type="text/css">
<!--
body {
	background: #abc;
	font-size: 14px;
	font-family: Verdana, Tahoma, Arial, Helvetica, sans-serif;
	font-weight: bold;
	text-align: center;
	color: #303030;
	margin: 30px auto;
	padding: 0px;
}
div {
	text-align: center;
	margin: auto;
	padding: 5px;
	border: 1px solid #123;
	background: #37a;
	width: 50%;
	height: auto;
}
table {
	border: 1px solid #123;
	width: 100%;
	margin: auto;
}
.color1 {
	background: #def;
	color: #321;
	font-style: italic;
	font-size: 12px;
}
.color2 {
	background: #bcd;
	color: #322;
	font-style: italic;
	font-size: 12px;
}
th {
	background: #9ab;
	color: #321;
	font-size: 15px;
	text-decoration: underline;
	padding: 5px;
	border-bottom: 3px solid #321;
}
#footer {
	background: #9ab;
	padding: 2px;
}
form {
	margin: 0px;
}
#link {
	text-align: center;
	font-size: 8px;
	background: none;
	border: none;
	margin: 0px auto;
	padding: 0px;
}
a:link, a:visited, a:active   {
        text-decoration: underline;
		color: #303030;
}
a:hover {
	color: #000;
	text-decoration: none;
}
#zip {
	color: #123;
	width: 30%;
	height: 20px;
	margin: 0px auto;
	margin-bottom: 2px;
	padding: 0px;
	padding-bottom: 5px;
	font-weight: bold;
	background-color: #bcd;
	border: 2px solid #fff;
}
#zip:hover {
	background-color: #345;
	color: #fff;
}
#dl {
	color: #123;
	width: 30%;
	height: 20px;
	margin: 0px auto;
	margin-bottom: 2px;
	padding: 0px;
	padding-bottom: 5px;
	font-weight: bold;
	background-color: #def;
	border: 2px solid #fff;
}
#dl:hover {
	background-color: #345;
	color: #fff;
}
.list {
	border: none;
}
.servname {
	font-size: 15px;
}
.path {
	font-weight: normal;
	font-size: 10px;
}
.count {
	font-size: 11px;
	color: #800;
}
.link {
	font-size: 13px;
}
-->
</style>
</head>
<body>
<div >
';
	
	// action only if a checkbox was marked
	if ((!$_POST['server']) && (!$_POST['download'])) {
		echo $output;
		echo "\t" . '<form action="'.$_SERVER['SCRIPT_NAME'].'" method="post">
		<table cellpadding="1px" cellspacing="0px ">
			<tr><th colspan="2">Choose server for track backup:</th></tr>' . "\n\t\t\t";
				
		// create drop down menu
		$i = 0;
		$col[0] = 'color1';
		$col[1] = 'color2';
		 foreach ($server as $key => &$menu){	
			echo '<tr class="'.$col[$i%2].'"><td>'.$menu[4].'</td>';
			echo "<td><input type=\"checkbox\" name=\"server[]\" value=\"$key\" ></td></tr>\n\t\t\t";  
			$i++;
			}
			echo "<tr id=\"footer\" ><td colspan=\"2\">
			<input id=\"zip\" type=\"submit\" value=\"Backup Tracks\" name=\"zip\" onfocus=\"this.blur()\" onclick=\"this.blur()\" >&nbsp;&nbsp;
			<input id=\"dl\" type=\"submit\" value=\"List Backups\" name=\"download\" onfocus=\"this.blur()\" onclick=\"this.blur()\"></td></tr>\n";
			echo "\t\t</table>\n\t</form>";	
		}
		
		// got action zip  
		if (isset($_POST['server']))   {
			echo $output;
			echo "\t" . '<form action="'.$_SERVER['SCRIPT_NAME'].'" method="post">' . "\n\t\t" . '<table cellpadding="4px" cellspacing="0px ">' . "\n\t\t\t" . '<tr><th>Process State:</th></tr>';
			
			foreach ($_POST['server'] as $key) {
				$allserver[] = $server[$key];
				}
			
			$i = 0;	
			$n = 0;
			$col[0] = 'color1';
			$col[1] = 'color2';			
			foreach ($allserver as $server) {
					
				if ($i == "0") {
					echo "\n\t\t\t" . '<tr class="'.$col[$n%2].'">'; 
					$n++;
					}
				// define connection timeout
				$fp = @fsockopen($server[0], $server[1], $errno, $errstr, 2);

				if(!$fp) {
					echo "<td>Server Offline</td>\n";
					}
				else {
					
					// connect to server
					$client = new IXR_Client_Gbx();
					$client->InitWithIp($server[0], $server[1]) or die("<td>can\'t connect to server<br><td>\n");
					$client->query('Authenticate', $server[2], $server[3]) or die("<td>authentication failed</td>\n");
					
					// get server name
					$client->query('GetServerName') or die('<td>GetServerName failed</td>\n');
					$servername = $client->getResponse();
					$servernamehtml = $cp->toHTML($servername);
					
					// get dedipath
					$client->query('GetTracksDirectory') or die('<td>GetTracksDirectory failed</td>\n');
					$dedipath = $client->getResponse();
						
					// save matchsettings
					$client->query('SaveMatchSettings', 'MatchSettings/' . $server[5]) or die ('<td>can\'t save tracklist file !!!</td>\n');
					//  define path to temp tracklist file
					$tlf = $dedipath . 'MatchSettings/' . $server[5];
				
					// define zip name
					$zipfile = './zip/' . $date . '_' . $server[4] . '_tracks.zip';
					$zip = new ZipArchive();
					if ($zip->open($zipfile, ZIPARCHIVE::CREATE)!==TRUE) {
							exit("<td>cannot open $zipfile </td>\n");
						}
					// get challenges, and create zip
					while (true) {
						$client->query('GetChallengeList', $max, $i) or die("<td>GetChallengeList failed</td>\n");
						$tracklist = $client->getResponse();
						if (empty($tracklist)) break;
						foreach($tracklist as $track) {
							$name = $track['FileName'];
							$zip->addFile($dedipath . $name);	
						}
						if (count($tracklist) < $max) break;
						$i += $max;
						}
						$zip->addFile($tlf);
						$zip->close();
						//unlink($tlf);
						// write log
						$str = './backup/';
						$ziplog = str_replace($str ,"" ,$zipfile);
						fwrite($handle, $ziplog . " from " . '"' . $dedipath . '"' . " with " . ($i + count($tracklist)) . " track(s) created.\r\n") 
							or die ('<td>Can\'t write log file</td>\n');
						echo "<td>\n\t\t\t\t<table class=\"list\">\n\t\t\t\t<tr><td class=\"servname\">$servernamehtml</td></tr>\n\t\t\t\t<tr><td class=\"path\">$dedipath</td></tr>\n\t\t\t\t<tr><td class=\"count\">" . ($i + count($tracklist)) . " track(s) currently at the server</td></tr>\n";
						// close connection
						$client->Terminate();
						echo "\t\t\t\t<tr><td class=\"link\"><a href=\"$zipfile\">Download Track Pack</a></td></tr>\n\t\t\t\t</table>\n\t\t\t</td></tr>";
				}
			}
			echo "<tr id=\"footer\" ><td colspan=\"2\">
			<input id=\"zip\" type=\"submit\" value=\"Main Page\" name=\"zip\" onfocus=\"this.blur()\" onclick=\"this.blur()\" >&nbsp;&nbsp;
			<input id=\"dl\" type=\"submit\" value=\"List Backups\" name=\"download\" onfocus=\"this.blur()\" onclick=\"this.blur()\"></td></tr>\n\n\t\t</table>\n\t</form>";
		}

		// got action list backups
		if (isset($_POST['download'])) {
			$n = 0;
			$col[0] = 'color1';
			$col[1] = 'color2';	
			echo $output;
			echo "\t" . '<form action="'.$_SERVER['SCRIPT_NAME'].'" method="post">' . "\n\t\t" . '<table cellpadding="4px" cellspacing="0px ">' . "\n\t\t\t" . '<tr><th>Track Pack List</th></tr>';
			if ($handle = opendir('./zip')) {
				while (false !== ($file = readdir($handle))) {
					if ($file != "." && $file != "..") {
						$size = filesize("./zip/$file");
						//$size = $size / 1024 / 1024;
						$size = formatBytes($size);
						echo "\n\t\t\t" . '<tr class="'.$col[$n%2].'"><td><a href="./zip/'.$file.'">'.$file.'</a> : '.$size.'</td></tr>';
						$n++;
						}
					}
					closedir($handle);
				}
			echo "\t\t\t<tr id=\"footer\" ><td colspan=\"2\">
			<input id=\"zip\" type=\"submit\" value=\"Main Page\" name=\"zip\" onfocus=\"this.blur()\" onclick=\"this.blur()\" ></td></tr>\n\t\t</table>\n\t</form>";			
			}
			
echo '
</div>
	<div id="link">&copy; 2009 by <a href="http://tmf.game-host.org" target="_blank" onfocus="this.blur()" onclick="this.blur()">Nouseforname</a></div>
</body>
</html>
';
?>